import '../mcg_extension.dart';

extension MyMapExtension on Map {
  //[key,title]
  Future<T?> selectOne<T>({String title = '', String? message}) async {
    final _items = entries
        .map((e) => BottomSheetItem<T>(
              name: e.value.toString(),
              value: e.key,
            ))
        .toList()
      ..add(BottomSheetItem.cancel());

    var value = _items.length > 5
        ? await OverBottomSheet.show(BottomSheetPanel.list(
            multipleItemBackgrounds: true,
            title: title,
            subTitle: message,
            items: _items,
          ))
        : await OverBottomSheet.show(BottomSheetPanel.simpleList(
            title: title,
            subTitle: message,
            items: _items,
          ));

    return value as T?;
  }

  // Future<T?> makeSheet<T>({String title = '', String? message}) async {
  //   var value = await Sheet.make(
  //       title: title,
  //       message: message,
  //       actions: entries
  //           .map((e) => SheetAction(
  //                 onPressed: () {
  //                   Get.back(result: e.key);
  //                 },
  //                 title: e.value.toString(),
  //               ))
  //           .toList(),
  //       cancelAction: SheetAction(
  //         onPressed: () {
  //           Get.back(result: null);
  //         },
  //         title: 'back'.translate,
  //         isDestructiveAction: true,
  //       ));
  //   return value as T?;
  // }
}
