part of '../bottomsheetpanel.dart';

class _DefaultBottomSheetPanel extends StatelessWidget {
  final String? title;
  final String? subTitle;
  //? Cancel button istiyorsan bunu girmelisin
  final String? cancelText;
  final String? okText;
  final Color? primaryColor;

  _DefaultBottomSheetPanel({
    this.title,
    this.subTitle,
    this.cancelText,
    this.okText,
    this.primaryColor,
  });
  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.only(left: 16, right: 16, bottom: 16),
      child: Column(
        mainAxisSize: MainAxisSize.min,
        children: [
          Flexible(
            child: Container(
              padding: Inset(16),
              child: Column(
                mainAxisSize: MainAxisSize.min,
                crossAxisAlignment: CrossAxisAlignment.center,
                children: [
                  Container(width: double.infinity),
                  if (title != null) title.text.color(Fav.design.sheet.contentText).bold.fontSize(24).center.make(),
                  if (subTitle != null) 4.heightBox,
                  if (subTitle != null) Flexible(child: SingleChildScrollView(child: subTitle.text.color(Fav.design.sheet.contentText.withAlpha(200)).fontSize(16).center.make())),
                ],
              ),
            ).pb12,
          ),
          Row(
            mainAxisSize: MainAxisSize.min,
            children: [
              if (cancelText != null)
                Expanded(
                  child: TextButton(
                      style: TextButton.styleFrom(shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(9)), backgroundColor: (primaryColor ?? Fav.design.primary).withAlpha(25), tapTargetSize: MaterialTapTargetSize.shrinkWrap),
                      onPressed: () {
                        OverBottomSheet.selectBottomSheetItem(false);
                      },
                      child: Padding(
                        padding: EdgeInsets.all(isWeb ? 4.0 : 0.0),
                        child: Center(child: (cancelText).text.fontSize(20).color(primaryColor ?? Fav.design.primary).make()),
                      )),
                ),
              if (cancelText != null) 8.widthBox,
              Expanded(
                child: TextButton(
                    style: TextButton.styleFrom(shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(9)), backgroundColor: primaryColor ?? Fav.design.primary, tapTargetSize: MaterialTapTargetSize.shrinkWrap),
                    onPressed: () {
                      OverBottomSheet.selectBottomSheetItem(true);
                    },
                    child: Padding(
                      padding: EdgeInsets.all(isWeb ? 4.0 : 0.0),
                      child: Center(child: (okText ?? 'ok'.translate).text.fontSize(20).bold.color(Colors.white).make()),
                    )),
              ),
            ],
          ),
        ],
      ),
    );
  }
}
