part of '../bottomsheetpanel.dart';

class _SimpleBottomSheetPanel extends StatelessWidget {
  final String? title;
  final String? subTitle;
  final List<BottomSheetItem>? items;
  final BottomSheetPanelHeight bottomSheetPanelHeight;
  final bool barrierDismissible;

  _SimpleBottomSheetPanel({this.title, this.subTitle, required this.items, this.bottomSheetPanelHeight = BottomSheetPanelHeight.L, this.barrierDismissible = true});
  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.only(left: 16, right: 16, bottom: 16),
      child: Column(
        mainAxisSize: MainAxisSize.min,
        children: [
          if (title != null || subTitle != null) PanelHeaderWidget(title: title, subTitle: subTitle).pb12,
          Flexible(
            child: Material(
              shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(_kBorderRadius)),
              color: Fav.design.sheet.card,
              child: ListView.separated(
                physics: BouncingScrollPhysics(),
                padding: EdgeInsets.all(0),
                shrinkWrap: true,
                itemBuilder: (context, index) {
                  final _item = items![index];
                  return InkWell(
                    onTap: () {
                      OverBottomSheet.selectBottomSheetItem(_item.value);
                    },
                    borderRadius: items!.length == 1
                        ? BorderRadius.circular(_kBorderRadius)
                        : index == 0
                            ? BorderRadius.only(topLeft: Radius.circular(_kBorderRadius), topRight: Radius.circular(_kBorderRadius))
                            : index == items!.length - 1
                                ? BorderRadius.only(bottomLeft: Radius.circular(_kBorderRadius), bottomRight: Radius.circular(_kBorderRadius))
                                : BorderRadius.circular(0),
                    child: Padding(
                      padding: Inset(16),
                      child: Row(
                        crossAxisAlignment: CrossAxisAlignment.center,
                        children: [
                          if (_item.icon != null) _item.icon!.icon.color(_item.itemColor ?? Fav.design.sheet.headerText).make(),
                          if (_item.icon != null) 16.widthBox,
                          Expanded(child: _item.name.text.color(_item.itemColor ?? Fav.design.sheet.contentText).setBold(_item.bold).align(_item.icon != null || _item.suffix != null ? TextAlign.start : TextAlign.center).make()),
                          if (_item.suffix != null) 16.widthBox,
                          if (_item.suffix != null) _item.suffix!,
                        ],
                      ),
                    ),
                  );
                },
                separatorBuilder: (context, index) {
                  return Container(
                    width: double.infinity,
                    height: 0.5,
                    color: Fav.design.primaryText.withAlpha(10),
                  );
                },
                itemCount: items!.length,
              ),
            ),
          ),
        ],
      ),
    );
  }
}
