import 'package:flutter/material.dart';

import '../../../mcg_extension.dart';

//? bu diger panellerden farkli olarak Bottomsheetpanel.widget icinden cagriliyor
class SureBottomSheetPanel extends StatelessWidget {
  final String? title;
  final String? subTitle;
  final String? cancelText;
  final String? yesText;
  final Color? primaryColor;

  SureBottomSheetPanel({
    this.title,
    this.subTitle,
    this.cancelText,
    this.yesText,
    this.primaryColor,
  });
  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.only(left: 16, right: 16, bottom: 16),
      child: Column(
        mainAxisSize: MainAxisSize.min,
        children: [
          Flexible(
            child: Container(
              // decoration: BoxDecoration(color: Fav.design.sheet.card, borderRadius: BorderRadius.circular(_kBorderRadius)),
              padding: Inset(16),
              child: Column(
                mainAxisSize: MainAxisSize.min,
                crossAxisAlignment: CrossAxisAlignment.center,
                children: [
                  Container(width: double.infinity),
                  (title ?? 'sure'.translate).text.color(Fav.design.sheet.contentText).bold.fontSize(24).center.make(),
                  if (subTitle != null) 4.heightBox,
                  if (subTitle != null) Flexible(child: SingleChildScrollView(child: subTitle.text.color(Fav.design.sheet.contentText.withAlpha(200)).fontSize(16).center.make())),
                ],
              ),
            ).pb12,
          ),
          Column(
            mainAxisSize: MainAxisSize.min,
            children: [
              TextButton(
                  style: TextButton.styleFrom(shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(9)), backgroundColor: primaryColor ?? Fav.design.primary, tapTargetSize: MaterialTapTargetSize.shrinkWrap),
                  onPressed: () {
                    OverBottomSheet.selectBottomSheetItem(true);
                  },
                  child: Padding(
                    padding: EdgeInsets.all(isWeb ? 4.0 : 0.0),
                    child: Center(child: (yesText ?? 'yes'.translate).text.fontSize(20).bold.color(Colors.white).make()),
                  )),
              8.heightBox,
              TextButton(
                  style: TextButton.styleFrom(shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(9)), backgroundColor: (primaryColor ?? Fav.design.primary).withAlpha(25), tapTargetSize: MaterialTapTargetSize.shrinkWrap),
                  onPressed: () {
                    OverBottomSheet.selectBottomSheetItem(false);
                  },
                  child: Padding(
                    padding: EdgeInsets.all(isWeb ? 4.0 : 0.0),
                    child: Center(child: (cancelText ?? 'back'.translate).text.fontSize(20).color(primaryColor ?? Fav.design.primary).make()),
                  )),
            ],
          ),
        ],
      ),
    );
  }
}
