import 'package:flutter/material.dart';

import '../../mcg_extension.dart';
import '../../widgets/editablesearchtextfield.dart';
import 'other/header_widget.dart';

part 'bottomsheet_panels/child.dart';
//* Istedigin kadar type olusturabilirsin.

part 'bottomsheet_panels/form.dart';
part 'bottomsheet_panels/list.dart';
part 'bottomsheet_panels/multipleselectlist.dart';
part 'bottomsheet_panels/simple.dart';
part 'bottomsheet_panels/default.dart';
part 'bottomsheet_panels/simple_group.dart';

const _kBorderRadius = 12.0;

class BottomSheetPanel extends StatelessWidget implements IPanel {
  final Widget? child;
  final String? title;
  final String? subTitle;
  final List<BottomSheetItem>? items;
  final List<BottomSheetFormGroup>? formGroups;
  final List<BottomSheetGroup>? groups;
  final int _type;
  final BottomSheetPanelHeight bottomSheetPanelHeight;
  final bool? dense;
  final bool? multipleItemBackgrounds;
  final String? okButtonText;
  final bool useNavigator;

  ///Kaydirma acik olacak fakat cizgi istemiyorsan kullanabilirsin
  final bool removePill;
  final String? cancelText;
  final Color? primaryColor;

  /// Eger geri birsey  dondurecek bir tus koyacaksan overbottomsheetde geri dondurmek icin tus var
  BottomSheetPanel.child({required this.child, this.bottomSheetPanelHeight = BottomSheetPanelHeight.L, this.barrierDismissible = true, this.removePill = false})
      : title = null,
        subTitle = null,
        items = null,
        dense = null,
        formGroups = null,
        groups = null,
        multipleItemBackgrounds = null,
        primaryColor = null,
        cancelText = null,
        okButtonText = null,
        useNavigator = true,
        _type = 0;

  BottomSheetPanel.defaultPanel({this.title, this.subTitle, this.okButtonText, this.primaryColor, this.cancelText, this.bottomSheetPanelHeight = BottomSheetPanelHeight.L, this.barrierDismissible = true, this.removePill = false})
      : child = null,
        dense = null,
        formGroups = null,
        groups = null,
        items = null,
        multipleItemBackgrounds = null,
        useNavigator = false,
        _type = 5;

  BottomSheetPanel.simpleList({this.title, this.subTitle, required this.items, this.bottomSheetPanelHeight = BottomSheetPanelHeight.L, this.barrierDismissible = true, this.removePill = false})
      : child = null,
        dense = null,
        formGroups = null,
        groups = null,
        multipleItemBackgrounds = null,
        okButtonText = null,
        useNavigator = false,
        primaryColor = null,
        cancelText = null,
        _type = 1;

  BottomSheetPanel.list({
    this.title,
    this.subTitle,
    required this.items,
    this.bottomSheetPanelHeight = BottomSheetPanelHeight.L,
    this.barrierDismissible = true,
    this.removePill = false,
    this.dense = false,
    this.multipleItemBackgrounds = false,
  })  : child = null,
        okButtonText = null,
        primaryColor = null,
        cancelText = null,
        useNavigator = false,
        formGroups = null,
        groups = null,
        _type = 2;

  BottomSheetPanel.multipleSelectList({
    this.title,
    this.subTitle,
    required this.items,
    this.bottomSheetPanelHeight = BottomSheetPanelHeight.L,
    this.barrierDismissible = true,
    this.removePill = false,
    this.dense = false,
    this.multipleItemBackgrounds = false,
    this.okButtonText,
  })  : child = null,
        formGroups = null,
        useNavigator = false,
        primaryColor = null,
        cancelText = null,
        groups = null,
        _type = 3;

//? Ornek
//  final _result = await OverBottomSheet.show(BottomSheetPanel.form(groups: [
//                   BottomSheetGroup(items: [
//                     BottomSheetItem<String>(name: 'Ahmet ', value: 'dfsdf'),
//                     BottomSheetItem<String>(name: 'Mehmet ', value: '123'),
//                   ], groupKey: 'hhey', groupName: 'Tekli secim'),
//                   BottomSheetGroup(
//                       type: BottomSheetGroupLayoutType.multipleSelectList,
//                       items: [
//                         BottomSheetItem<String>(name: 'AhVelimet ', value: 'dfsdf'),
//                         BottomSheetItem<String>(name: 'Ohhh ', value: '123'),
//                       ],
//                       groupKey: 'aaa',
//                       groupName: 'Coklu Secim'),
//                 ]));
  BottomSheetPanel.form({
    this.title,
    this.subTitle,
    required this.formGroups,
    this.bottomSheetPanelHeight = BottomSheetPanelHeight.L,
    this.barrierDismissible = true,
    this.removePill = false,
    this.dense = false,
    this.multipleItemBackgrounds = false,
    this.okButtonText,
  })  : child = null,
        items = null,
        primaryColor = null,
        cancelText = null,
        useNavigator = false,
        groups = null,
        _type = 4;

  BottomSheetPanel.simpleGroup({
    this.title,
    this.subTitle,
    required this.groups,
    this.bottomSheetPanelHeight = BottomSheetPanelHeight.L,
    this.barrierDismissible = true,
    this.removePill = false,
    this.dense = false,
  })  : child = null,
        items = null,
        primaryColor = null,
        cancelText = null,
        useNavigator = false,
        okButtonText = null,
        formGroups = null,
        multipleItemBackgrounds = false,
        _type = 6;

  @override
  Widget build(BuildContext context) {
    late Widget _current;
    if (_type == 0) {
      _current = _ChildBottomSheetPanel(child: child!);
    }
    if (_type == 1) {
      _current = _SimpleBottomSheetPanel(
        items: items,
        barrierDismissible: barrierDismissible,
        bottomSheetPanelHeight: bottomSheetPanelHeight,
        subTitle: subTitle,
        title: title,
      );
    }
    if (_type == 2) {
      _current = _ListBottomSheetPanel(
        items: items!,
        barrierDismissible: barrierDismissible,
        bottomSheetPanelHeight: bottomSheetPanelHeight,
        subTitle: subTitle,
        title: title,
        dense: dense!,
        multipleItemBackgrounds: multipleItemBackgrounds!,
      );
    }
    if (_type == 3) {
      _current = _MultipleSelectListBottomSheetPanel(
        items: items!,
        barrierDismissible: barrierDismissible,
        bottomSheetPanelHeight: bottomSheetPanelHeight,
        subTitle: subTitle,
        title: title,
        dense: dense!,
        multipleItemBackgrounds: multipleItemBackgrounds!,
        okButtonText: okButtonText,
      );
    }
    if (_type == 4) {
      _current = _FormBottomSheetPanel(
        groups: formGroups!,
        barrierDismissible: barrierDismissible,
        bottomSheetPanelHeight: bottomSheetPanelHeight,
        subTitle: subTitle,
        title: title,
        dense: dense!,
        multipleItemBackgrounds: multipleItemBackgrounds!,
        okButtonText: okButtonText,
      );
    }

    if (_type == 5) {
      _current = _DefaultBottomSheetPanel(
        subTitle: subTitle,
        title: title,
        okText: okButtonText,
        cancelText: cancelText,
        primaryColor: primaryColor,
      );
    }

    if (_type == 6) {
      _current = _SimpleGroupBottomSheetPanel(
        groups: groups!,
        barrierDismissible: barrierDismissible,
        bottomSheetPanelHeight: bottomSheetPanelHeight,
        subTitle: subTitle,
        title: title,
        dense: dense!,
      );
    }

    return _current;
  }

  @override
  bool barrierDismissible;
}
