import 'package:flutter/material.dart';
import 'package:mcg_extension/mcg_extension.dart';

enum BottomSheetPanelHeight { M, L }

class BottomSheetItem<T> {
  final T? value;
  final String name;
  final IconData? icon;
  final Color? itemColor;
  final Widget? suffix;
  final bool bold;

  BottomSheetItem({
    this.value,
    required this.name,
    this.icon,
    this.itemColor,
    this.suffix,
    this.bold = false,
  });

  BottomSheetItem.cancel()
      : value = null,
        name = 'cancel'.translate.toUpperCase(),
        icon = null,
        suffix = null,
        bold = true,
        itemColor = Colors.redAccent;
}

class BottomSheetFormGroup {
  final String groupKey;
  final String? groupName;
  List<BottomSheetItem> items;
  final BottomSheetGroupLayoutType type;
  BottomSheetFormGroup({
    required this.groupKey,
    this.groupName,
    required this.items,
    this.type = BottomSheetGroupLayoutType.simpleList,
  });
}

class BottomSheetGroup {
  final String? groupName;
  List<BottomSheetItem> items;
  final BottomSheetGroupLayoutType type;
  BottomSheetGroup({
    this.groupName,
    required this.items,
    this.type = BottomSheetGroupLayoutType.simpleList,
  });
}

//row un layout kismi yazilmadi
enum BottomSheetGroupLayoutType { row, simpleList, multipleSelectList }

abstract class IPanel {
  late bool barrierDismissible;
}
